; ////////////////////////////
; /  I/O TRANIG UNIT MANUAL  /
; /	 PROGRAM 1 - 8	     /
; /	    97/04/10	     /
; ////////////////////////////

	ORG 8000H
; ***********************
; *	 PROGRAM 1	*
; ***********************

PRG1:	IN	A,(0E1H)
	OUT	(0E0H),A
	NOP			;00CD / BITSETCALL
	NOP			;000A /  鎞ɂ
	NOP			;0080 /   ύX
	JP	PRG1

; ***********************
; *	  BIT SET	*
; ***********************

BITSET:	LD	B,8
	LD	HL,0FFF8h
BISE10:	SLA	A
	JP	C,BISE11
	LD	C,3Fh
	JP	BISE12
BISE11:	LD	C,06h
BISE12:	LD	(HL),C
	INC	HL
	DJNZ	BISE10
	CALL	SCAN
	RET

; ***********************
; *	 PROGRAM 2	*
; ***********************

PRG2:	LD	SP,9F80h
	CALL	INIPIO
PR20:	LD	A,0FEH
	OUT	(3CH),A
	LD	A,1
	OUT	(3EH),A
	JP	PR20

; ***********************
; *	 PROGRAM 3	*
; ***********************

TIMER1m	EQU	0D2DH

PRG3:	LD	SP,9F80H
	CALL	INIPIO
PR30:	LD	A,0FEH
	OUT	(03CH),A
	LD	A,8
	OUT	(03EH),A
	CALL	TIMER1m
	LD	A,0FDH
	OUT	(03CH),A
	LD	A,40H
	OUT	(03EH),A
	CALL	TIMER1m
	LD	A,0FBH
	OUT	(03CH),A
	LD	A,1
	OUT	(03EH),A
	CALL	TIMER1m
	JP	PR30

; ***********************
; *	 PROGRAM 4	*
; ***********************

PRG4:	LD	SP,9F80H
	CALL	INIPIO
PR40:	LD	A,0FEH
	OUT	(03CH),A
	LD	A,8
	OUT	(03EH),A
	CALL	TIMER1m
	LD	A,0
	OUT	(03EH),A
	CALL	TIMER1u
	LD	A,0FDH
	OUT	(03CH),A
	LD	A,40H
	OUT	(03EH),A
	CALL	TIMER1m
	LD	A,0
	OUT	(03EH),A
	CALL	TIMER1u
	LD	A,0FBH
	OUT	(03CH),A
	LD	A,1
	OUT	(03EH),A
	CALL	TIMER1m
	LD	A,0
	OUT	(03EH),A
	CALL	TIMER1u
	JP	PR40

TIMER1u:
	PUSH	BC
	LD	BC,161
	CALL	TIMER
	POP	BC
	RET

; ***********************
; *	 PROGRAM 5	*
; ***********************

SCAN	EQU	0D03H

PRG5:	LD	SP,9F80h
	CALL	INIPIO
	LD	A,0F7H
	OUT	(03CH),A
PR50:	IN	A,(03AH)
	LD	(0FFFFH),A
	CALL	SCAN
	CALL	TIMER1m
	JP	PR50

; ***********************
; *	 PROGRAM 6	*
; ***********************

PRG6:	LD	SP,9F80H
	CALL	INIPIO
PR60:	LD	HL,DATA
	LD	BC,03FEH
PR61:	LD	A,0F7H
	AND	C
	OUT	(03CH),A
	LD	A,(HL)
	OUT	(03EH),A
	CALL	TIMER1m
	IN	A,(03AH)
	PUSH	BC
	PUSH	HL
	CALL	HEXBIN
	CALL	SCAN
	POP	HL
	POP	BC
	LD	A,0
	OUT	(03EH),A
	CALL	TIMER1u
	RLC	C
	INC	HL
	DJNZ	PR61
	JP	PR60

DATA	DB	8,40H,1

; ***********************
; *   PIO Initialize    *
; ***********************

INIPIO:
	LD	A,00000000b
	OUT	(1Dh),A
	LD	A,00000000b
	OUT	(3Bh),A
	LD	A,11111111b
	OUT	(3Dh),A
	LD	A,11111111b
	OUT	(3FH),A
	RET

; ***********************
; *	HEX -> Bin.	*
; ***********************

ADRS1	EQU	0FF93h
DISP	EQU	0D0Fh

HEXBIN:	LD	B,A
	LD	C,4
	LD	HL,ADRS1
HEXBIN1:
	CALL	BIN
	RLD	
	CALL	BIN
	RLD
	DEC	L
	DEC	C
	JP	NZ,HEXBIN1
	CALL	DISP
	RET

BIN:	SLA	B
	JP	C,BIN1
	XOR	A
	RET
BIN1:	LD	A,1
	RET

; ***********************
; *	50msec TIMER	*
; ***********************

TIMER50:			;5
	PUSH	BC		;4
	LD	BC,83328	;3
	CALL	TIMER		;6*BC+15
	POP	BC		;3
	RET			;3

TIMER:				;5
	PUSH	AF		;4
LOOP:	DEC	BC		;1
	LD	A,B		;1
	OR	C		;1
	JP	NZ,LOOP		;3
	POP	AF		;3
	RET			;3


; ***********************
; *	 PROGRAM 7	*
; ***********************

INISIO	EQU	0D0CH
TIMER1	EQU	0D27H
TIMER20	EQU	0D21H
HEXASC	EQU	0D1BH
RS_CH	EQU	0FF54h

PRG7:	LD	SP,9F80H
	LD	A,0
	LD	(RS_CH),A
	CALL	INISIO
	CALL	INIPIO
PR70:	LD	A,1
	OUT	(0E0H),A
	IN	A,(0E1H)
	LD	B,A
	CALL	TIMER20
	LD	A,0
	OUT	(0E0H),A
	LD	A,B
	CALL	HEXASC
	LD	B,A
PR71:	IN	A,(02BH)
	BIT	0,A
	JP	Z,PR71
	LD	A,B
	OUT	(02AH),A
	CALL	TIMER1
	JP	PR70

; ***********************
; *	 PROGRAM 8	*
; ***********************
;  INTERRUPT CONTROL

VCTTBL	EQU	8800h
INTR0	EQU	34h		;۰
INTR1	EQU	INTR0+1
INTR2	EQU	INTR0+2
INTR3	EQU	INTR0+3
LER	EQU	0000000000000000b
IVR	EQU	LOW VCTTBL
PGR	EQU	0000000000000000b
IMR	EQU	1111101111111111b

PRG8:	LD	SP,9F80H
	IM	2
	LD	A,HIGH VCTTBL
	LD	I,A
	LD	A,0
	LD	(RS_CH),A
	CALL	INISIO
	CALL	INIINTR
	LD	A,0
	LD	(9000H),A
PR80:	EI
PR81:	LD	A,(9000H)
	AND	A
	JP	NZ,PR82
	CALL	SCAN
	JP	PR81

PR82:	LD	A,0
	LD	(9000H),A
	LD	A,(9001H)
	CALL	HEXBIN
	JP	PR80

INIINTR:
	LD	A,LOW LER
	OUT	(INTR0),A
	LD	A,HIGH LER
	OUT	(INTR1),A
	LD	A,IVR
	OUT	(INTR3),A
	LD	A,LOW PGR
	OUT	(INTR0),A
	LD	A,HIGH PGR
	OUT	(INTR1),A
	LD	A,LOW IMR
	OUT	(INTR2),A
	LD	A,HIGH IMR
	OUT	(INTR3),A
	RET

INT:	PUSH	AF
	IN	A,(02AH)
	LD	(9001H),A
	LD	A,1
	LD	(9000H),A
	POP	AF
	RETI

DUMMY_INT:
	EI
	RETI

	ORG	VCTTBL
	DW	DUMMY_INT	;IR 0:
	DW	DUMMY_INT	;IR 1:
	DW	DUMMY_INT	;IR 2:
	DW	DUMMY_INT	;IR 3:
	DW	DUMMY_INT	;IR 4:
	DW	DUMMY_INT	;IR 5:
	DW	DUMMY_INT	;IR 6:
	DW	DUMMY_INT	;IR 7:
	DW	DUMMY_INT	;IR 8:
	DW	DUMMY_INT	;IR 9:
	DW	INT		;IR10:RS_CH0_Receive
	DW	DUMMY_INT	;IR11:
	DW	DUMMY_INT	;IR12:
	DW	DUMMY_INT	;IR13:
	DW	DUMMY_INT	;IR14:
	DW	DUMMY_INT	;IR15:

	END
